#include "defines.h"
/*     Bed a Binary EDitor for Linux and for Rxvt running under Linux.       */
/*     Copyright (C) 1998  Jaap Korthals Altes <jkaltes@cyberbrain.com>      */
/*                                                                           */
/*     Bed is free software; you can redistribute it and/or modify           */
/*     it under the terms of the GNU General Public License as published by  */
/*     the Free Software Foundation; either version 2 of the License, or     */
/*     (at your option) any later version.                                   */
/*                                                                           */
/*     Bed is distributed in the hope that it will be useful,                */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of        */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         */
/*     GNU General Public License for more details.                          */
/*                                                                           */
/*     You should have received a copy of the GNU General Public License     */
/*     along with bed; if not, write to the Free Software                    */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.             */
/*                                                                           */
/* Sun Dec  6 18:34:27 1998                                                  */

/***
 *  v2  2000.09.20  Jim Blackson	moved definiton of TRUNCATE to offtypes.h;
 *					rename truncate to truncatefile.
 */

#include "desturbe.h"
#include <features.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifdef __linux__
#include <linux/fs.h>
#include <linux/cdrom.h>
#endif
#include <sys/ioctl.h>
#include <limits.h>
#include <unistd.h>
#include <ctype.h>
#include "memory.h"
#include "system.h"
#include "myalloc.h"
#include "main.h"
#ifdef USE_MMAP
const size_t mmap_page_size = (size_t) sysconf (_SC_PAGESIZE);
#define	FREEMMAP(str, len) {if(nommap){free(str);}else {MUNMAP(str,len);}}
#define BIGGERMMAPBLOCK
#endif
#define EXTRAMMAP 0
#if defined(USE_MMAP)&&!defined(BIGGERMMAPBLOCK)
int STBLOCKSIZE=mmap_page_size;

#else
//const int STBLOCKSIZE=1024;
int STBLOCKSIZE=4096;
#endif

int userblocksize=-1;
#if defined(BIGGERMMAPBLOCK) && defined(USE_MMAP)
#define MMAPBLOCKSIZE (mmap_page_size*4)
#define MMAPBLOCKTYPE BLOCKTYPE
#else
#define MMAPBLOCKSIZE BLOCKSIZE
#define MMAPBLOCKTYPE BLOCKTYPE
#endif /*BIGGERMMAPBLOCK */

inline int isup(int ch) { return (ch>='A'&&ch<='Z');}
inline int islow(int ch) { return (ch>='a'&&ch<='z');}
inline int tolow(int ch) {return ch+(-'A'+'a');}
inline int toup(int ch) {return ch+(-'a'+'A');}
inline int mklow(int ch) { return (isup(ch)?tolow(ch):ch);}
inline int mkup(int ch) { return (islow(ch)?toup(ch):ch);}




#define sizehigher(sizefile) (readat(&ch,1,(sizefile))>=1)

#define testsize( sizetest) sizehigher(sizetest)?0:((sizehigher((sizetest-1)))?1:0)

#define MAXCDSIZE 1024*1024*1024
char realsize=0;
const char *regexerrorstring=NULL;
#define re_search_2(pat,s1,l1,s2,l2,start,range,regs,stop) ((l2>0)?re_search_2(pat,s1,l1,s2,l2,start,range,regs,stop):re_search(pat,s1,l1,start,range,regs) )

OFFTYPE Memory::exploresize(int file,OFFTYPE begin=0, OFFTYPE end=MAXDISCSIZE) {
	char ch;
	OFFTYPE half;
	do {
		half=(OFFTYPE)((LARGERTYPE)(end+begin)/2);
		if(sizehigher((half)))
			begin=half+1;
		else
			end=half;
		} while(end>begin);

	return begin;
	}
#define EXPLORESIZE {if((filesize=exploresize(file,begin,end))>=MAXDISCSIZE) { errors=6; return;}}
OFFTYPE sizespecified=0;
void Memory::openfile(void) {
	OFFTYPE begin=0;
	OFFTYPE end = MAXDISCSIZE;
	char ch;
	file=-1;
#ifdef PROCLOCKSBUG
	if(!strcmp(filename,"/proc/locks")) {
		errors=9;
		return;
		}
#endif
	if(STAT(filename,&statdata)) {
		errors=8;	
		return;
		}
	if( S_ISFIFO(statdata.st_mode)  ) {
		errors=7;
		return;
		}
	if((file=LOPEN(filename,O_RDONLY LARGEFILE_FLAG BINARY_FLAG))<0) {
		errors=1;
		}
	else {
	if(userblocksize>0) {
		BLOCKSIZE=userblocksize;
		}
	else {
		if(statdata.st_blksize>0)
			BLOCKSIZE=statdata.st_blksize;
		else
			BLOCKSIZE=STBLOCKSIZE;
		}
	errors=0;
#ifdef __FreeBSD__
	blockreadonly=0;
//if(S_ISBLK(statdata.st_mode)) {
if(statdata.st_mode&S_IFBLK ) {
	if(LPREAD(file,&ch,1,0)<1) {
		int freebsdblocksize=1024;
		char buf[freebsdblocksize];
		if(LPREAD(file,buf,freebsdblocksize,0)==freebsdblocksize) {
		blockreadonly=freebsdblocksize;
		LSEEK(file,0,SEEK_SET);
		}
		}
	}
#endif
if(sizespecified) {
	filesize=sizespecified;
	return;
	}
#ifndef ALWAYSEXPLORESIZE
		if(S_ISREG(statdata.st_mode) ) {
			mmapfailed=0;
			filesize=statdata.st_size;
			if(testsize(filesize))
				return;
			goto catchall;
			}
		else   {
#ifdef __linux__
			if(S_ISBLK(statdata.st_mode)) {
				int blkgetsize;
				if(ioctl(file,BLKGETSIZE ,&blkgetsize)>=0) { 
					filesize= (OFFTYPE) blkgetsize*512;
					if(sizehigher(filesize)) 
						begin=filesize;
					else {
						if(sizehigher(filesize-1)) 
							return;
						else
							end=filesize-1;
						}
					}
			DEBUG("BLKGETSIZE failed\n");
/*Maybe a cdrom drive */
#ifdef CDROM_DISC_STATUS
			if(ioctl(file,CDROM_DISC_STATUS)<0) {
					 EXPLORESIZE;
				}
			else { /*Cdrom */
					char sbuf[8];
					OFFTYPE lookat=0x8050;
					OFFTYPE newbegin,newend;

					if(readat(sbuf,8,lookat)>=8&&memcmp(sbuf,sbuf+4,4)) {
						for(int i=0;i<4;i++) {
							if(sbuf[i]!=sbuf[7-i]) {
								DEBUG("No opposide");
								goto catchall;
								}
							}
						newbegin=(*((int*)&sbuf)*2048);
						if(sizehigher(newbegin-1)) {

							if(realsize) {
								begin=newbegin;
								newend=MAXCDSIZE;
								if(sizehigher(newend)) 
									begin=newend;
								else {
									end=newend;
								     }
								goto catchall;
								}
							else {
								filesize=newbegin;
								return ;
								}

							}
						else {
							end=newbegin; 
							}
						
						} /*End Read cdromsize */
					goto catchall;
				} /*END cdrom */
#else
					 EXPLORESIZE;
#endif
			} /*END block device */
#endif /*linux */
			} /*END not regular */
#endif /*ALWAYSEXPLORESIZE*/
		if(S_ISDIR(statdata.st_mode)) {
				errors=5;
				return;
				}
		 else 
		 	{
			catchall:
			 EXPLORESIZE ;
			}
	 	} /*END LOPEN) */
	}
void Memory::init(char *name) {
	char buf[MAXPATHLEN];
	mmapfailed=1;
	searchpos=0;
	lastforward=3;
	searchexpr=NULL;
	searchregs=NULL;
	searchstr=NULL;
	table=tablebase-SCHAR_MIN;
	expandfilename(buf,name);
	int len=strlen(buf)+1;
	filename=myallocar( char,len);
	memcpy(filename,buf,len);
	openfile();
	diskfilesize=filesize;
	}



Memory::Memory(char *name)  {
	 INITUSELSEEK;
//	filefp=NULL;
	init(name);
	}
int Memory::reinit(char *name) {
	if(file>0)
		LCLOSE(file);
	empty();
	if(filename)
		myfree( filename);
	 init(name);
	 return 0;
	}
int Memory::reinit(void) {
	return reinit(filename);
	}
int Memory::empty(void) {
	for(Treel *iter=tree.treecontrol->roottree;iter!=tree.NIL;iter=tree.next(iter))
		myfree( iter->data.buf);
	tree.empty();
	return 0;
	}

Memory::~Memory() {
	if(file>0)
		LCLOSE(file);
	empty();
	if(filename)
		myfree( filename);
	 DESTROYUSELSEEK;
	}


/* Bepaal of file veranderd is na opstarte of laatste keer saven             */
/* Ga alle nodes af en save die nodes.                                       */
/* Nodes delete                                                              */
/*                                                                           */
/* Saven van een node:                                                       */
/* 	- ga naar positie file;                                                  */
/* 	- schrijf gegevens in file                                               */
/* 	- delete gegevens                                                        */
/* Sat Oct  3 00:50:05 1998                                                  */

int Memory::savenode(Treel *node) {
	DEBUG("Save " BLOCKPRINT "\n",node->data.blocknr);
	OFFTYPE diff=filesize-(node->data.blocknr*BLOCKSIZE);
	if(diff>0) {
		SIZE_T size=(diff<BLOCKSIZE)?diff:BLOCKSIZE;
		if(node->data.size!=size)
			fprintf(stderr,"WARNING: savenode/1: not enough in node " BLOCKPRINT" " SIZE_TPRINT "!=" SIZE_TPRINT "\n",node->data.blocknr,size,node->data.size);
		return writeat(node->data.buf,node->data.size,node->data.blocknr*BLOCKSIZE);
		}
	return 0;
	}

int Memory::touched(void) {
	STATTYPE st;
	if(tmpbuffer(filename))
		return 0;
	if(STAT(filename,&st)<0)
		return -1;
	if(st.st_mtime!=statdata.st_mtime)
		return 5;
	if(st.st_size!=statdata.st_size)
		return 3;
	if(st.st_ino!=statdata.st_ino)
		return 4;
	return 0;
	}

int Memory::saveall(void) {
	if(file>0)
		LCLOSE(file);

	if((diskfilesize!=filesize&&(TRUNCATE(filename,filesize)<0))||(file=LOPEN(filename,O_RDWR LARGEFILE_FLAG BINARY_FLAG))<0) {
		int errors;
		readonly=1;
		if(errno)
			errors=errno;
		else
			errors=7777;
		if((file=LOPEN(filename,O_RDONLY LARGEFILE_FLAG BINARY_FLAG))<0) {
			if(errno)
				errors=errno;
			else
				errors=7777;
			}
		return errors;
		}
	for(Treel *iter=tree.treecontrol->roottree;iter!=tree.NIL;iter=tree.next(iter)) {
		if(savenode(iter)<0) {
				LCLOSE(file);
				if((file=LOPEN(filename,O_RDONLY LARGEFILE_FLAG BINARY_FLAG))<0) {
					if(errno)
						errors=errno;
					else
						errors=7777;
					}
				errors=8887;
				return errors;
				}
		myfree( iter->data.buf);
		}
	LCLOSE(file);
	tree.empty();
	if((file=LOPEN(filename,O_RDONLY LARGEFILE_FLAG BINARY_FLAG))<0) {
		if(errno)
			errors=errno;
		else
			errors=7777;
		}
	FSTAT(file,&statdata);
	diskfilesize=filesize;
	return errors;
	}
/*
	struct stat stats;
		fstat(handle,&stats);
		if(stats.st_ino==statdata.st_ino&&stats.st_dev==statdata.st_dev) {
			LCLOSE(handle);
			return saveall();
		}
		*/
int Memory::changednode(Treel *node) {
	char tmpbuf[BLOCKSIZE];
	OFFTYPE diff=filesize-((OFFTYPE)node->data.blocknr*BLOCKSIZE);
	if(diff>0) {
		SIZE_T size=(diff<BLOCKSIZE)?diff:BLOCKSIZE;
		if(node->data.size!=size)
			fprintf(stderr,"WARNING: changednode/1: not enough in node " BLOCKPRINT" " SIZE_TPRINT "!=" SIZE_TPRINT "\n",node->data.blocknr,size,node->data.size);
		blockreadat(tmpbuf,node->data.size,node->data.blocknr*BLOCKSIZE);
		return memcmp(tmpbuf, node->data.buf, node->data.size);
		}
	return 0;
	}
int Memory::changed(void) {
	OFFTYPE disksize;
	if(!tmpbuffer(filename)) 
		disksize=diskfilesize;
	else
		disksize=(OFFTYPE)1;

//	DEBUG("diskfilesize=" OFFPRINT " realsize=" OFFPRINT " tosavesize=" OFFPRINT "\n",diskfilesize,disksize,filesize);
	if(disksize!=filesize)
		return -1;
	for(Treel *iter=tree.treecontrol->roottree;iter!=tree.NIL;iter=tree.next(iter)) {
		if(changednode(iter))
			return -1;
		}
	for(Treel *iter=tree.treecontrol->roottree;iter!=tree.NIL;iter=tree.next(iter)) 
		myfree( iter->data.buf);
	tree.empty();
	return errors;
	}

int Memory::saveto(int handle) {
		char buf[BLOCKSIZE];
		BLOCKTYPE nr;
		SIZE_T did, ret=0;
		for(nr=0;(did=getblock(nr, buf));nr++) {
				ret=LWRITE(handle,buf,did);
				if(ret!=did) {
					return -1;
					}
				}
		if((maxnum((OFFTYPE)(nr-1)*BLOCKSIZE,0)+ret)!=filesize)
			return -1;
		return 0;
		}
SIZE_T Memory::getblockpiece(OFFTYPE beg,SIZE_T len,char *get) {
	BLOCKTYPE onder=beg/BLOCKSIZE;
	SIZE_T ret;
	SIZE_T in=beg%BLOCKSIZE;
	Treel *el=tree.search(onder);
	if(el!=tree.NIL) {
		ret=minnum(el->data.size,len);
		memmove(get,el->data.buf+in,ret);
		}
	else {
		ret=readat(get,len,beg);
		}
	return ret;
	}

OFFTYPE Memory::getpart(OFFTYPE beg,OFFTYPE len,char *gegs) {
	if(beg>=filesize) {
		if(beg==filesize&&!len)
			return 0;
		else
			return -1;
		}

	BLOCKTYPE start,bl;
	SIZE_T over; 
	OFFTYPE full,end=minnum(beg+len,filesize);
	len=end-beg;
	over=(BLOCKSIZE-(beg%BLOCKSIZE));
	over=minnum(len,over);

	if(getblockpiece(beg,over,gegs)!=over)
		return -1;


	full=len-over;
	if(full>0) {
		char *ptr;
		SIZE_T nog; 
		start=(beg/BLOCKSIZE)+1;
		bl=full/BLOCKSIZE+start;
		nog=full%BLOCKSIZE;
		ptr=gegs+over;
		for(BLOCKTYPE nr=start;nr<bl;nr++,ptr+=BLOCKSIZE) {
			if((BLOCKSIZE!=getblock(nr, ptr)))
				return -1;
			}
		if(getblockpiece(end-nog,nog,ptr)!=nog)
			return -1;
		}
	return len;
	}

OFFTYPE Memory::putpart(OFFTYPE beg,OFFTYPE aanlen,char *gegs) {
	if(beg>=filesize) {
		if(beg==filesize&&!aanlen)
			return 0;
		else
			return -1;
		}
	OFFTYPE len=aanlen;
	BLOCKTYPE start,bl;
	SIZE_T over;
	OFFTYPE end=minnum(beg+len,filesize),full;
	len=end-beg;
	over=(BLOCKSIZE-(beg%BLOCKSIZE));
	over=minnum(len,over);
	if(over)
		if(putblockpiece(beg,over,gegs)!=over)
			return -1;


	full=len-over;
	if(full>0) {
		char *ptr;
		SIZE_T nog;
		start=(beg/BLOCKSIZE)+1;
		bl=full/BLOCKSIZE+start;
		nog=full%BLOCKSIZE;
		ptr=gegs+over;
		for(BLOCKTYPE nr=start;nr<bl;nr++,ptr+=BLOCKSIZE) {
			if((BLOCKSIZE!=putblock(nr, ptr)))
				return -1;
			}
		if(putblockpiece(end-nog,nog,ptr)!=nog)
			return -1;
		}
	return len;
	}
SIZE_T Memory::saveto(int handle,OFFTYPE beg,OFFTYPE len) {
	if(beg>=filesize) {
		if(beg==filesize&&!len)
			return 0;
		else
			return -1;
		}
	OFFTYPE full;
	SIZE_T over;
	char buf[BLOCKSIZE];
	OFFTYPE end=beg+len;
	over=(BLOCKSIZE-(beg%BLOCKSIZE));
	over=minnum(len,over);
	if(over) {
		if(getpart(beg,over,buf)!=over)
			return -1;
		if(LWRITE(handle,buf,over)!=over)
			return -1;
		}


	full=len-over;
	if(full) {
		SIZE_T nog;
		BLOCKTYPE bl,start=(beg/BLOCKSIZE)+1;
		bl=full/BLOCKSIZE+start;
		nog=full%BLOCKSIZE;
		for(BLOCKTYPE nr=start;nr<bl;nr++) {
			if((BLOCKSIZE!=getblock(nr, buf)))
				return -1;
			SIZE_T ret=LWRITE(handle,buf,BLOCKSIZE);
			if(ret!=BLOCKSIZE) {
				return -1;
				}
			}
		if(nog) {
			if(getpart(end-nog,nog,buf)!=nog)
				return -1;
			if(LWRITE(handle,buf,nog)!=nog)
				return -1;
			}
		}
	return 0;
	}
Treel *Memory::gettreel(BLOCKTYPE blockiter) {
		Treel *el=tree.search(blockiter);
		if(el==tree.NIL) {
			char *gegs=myallocar( char,BLOCKSIZE);
			tree.insert((Data){blockiter,gegs,0});
			el=tree.search(blockiter);
			}
		return el;
		}
#ifdef HAS_PREAD
#define HAS_PWRITE 1
#endif
SIZE_T Memory::writeat(char *ptr,SIZE_T size,OFFTYPE offset) {
#ifdef HAS_PWRITE
	SIZE_T ret;
	ret=LPWRITE(file,ptr,size,offset);
	if(ret!=size) {
		fprintf(stderr,"write failed %d!=" SIZE_TPRINT "\n",ret,size);
		return -2;
		}
	return ret;
#else
	STARTUSELSEEK;
	OFFTYPE isof=LSEEK(file,offset,SEEK_SET);
	SIZE_T ret;
	if(isof!=offset) {
		fprintf(stderr,"writeat: lseek failed " OFFPRINT "!=" OFFPRINT "\n",isof,offset);
		STOPUSELSEEK;
		return -1;
		}
	ret=LWRITE(file,ptr,size);
	if(ret!=size) {
		fprintf(stderr,"write failed %d!=" SIZE_TPRINT "\n",ret,size);
		STOPUSELSEEK;
		return -2;
		}
	STOPUSELSEEK;
	return ret;
#endif
	}

SIZE_T Memory::blockreadat(char *ptr,SIZE_T size,OFFTYPE offset) {
		SIZE_T ret;
#ifdef HAS_PREAD
		ret=LPREAD(file,ptr,size,offset);
#else

		STARTUSELSEEK;
		OFFTYPE isof=LSEEK(file,offset,SEEK_SET);
		if(isof!=offset) {
//			fprintf(stderr,"readat: lseek failed " OFFPRINT "!=" OFFPRINT "\n",isof,offset);
			STOPUSELSEEK;
			return -1;
			}
		ret=LREAD(file,ptr,size);
#endif
		if(ret!=size) {
//			fprintf(stderr,"readat failed "SIZE_TPRINT  "!=" SIZE_TPRINT "\n",ret,size);
			STOPUSELSEEK;
			return -2;
			}
		STOPUSELSEEK;
		return ret;
}
#ifdef __FreeBSD__
inline SIZE_T Memory::readat(char *ptr,SIZE_T size,OFFTYPE offset) {
	if(blockreadonly>0) {
		OFFTYPE offunder=(offset/blockreadonly)*blockreadonly;
		SIZE_T extra=offset-offunder;
		SIZE_T blen=(((size+extra)+blockreadonly-1)/blockreadonly)*blockreadonly;
		char buf[blen];
		if(blockreadat(buf,blen,offunder)<(size+extra))
				return -1;
		memcpy(ptr,buf+extra,size);
		return size;		
		}
	else {
		return blockreadat(	ptr,size,offset);
		}
	}
#else
inline SIZE_T Memory::readat(char *ptr,SIZE_T size,OFFTYPE offset) {
		return blockreadat(	ptr,size,offset);
	}
#endif
#ifdef USE_MMAP
/*
Uses a other MMAPBLOCKSIZE larger than the general blocksize.
blocknr is given in terms of MMAPBLOCKSIZE
*/
#ifdef BIGGERMMAPBLOCK
SIZE_T Memory::mmapgetblock(MMAPBLOCKTYPE blocknr,char *buf) {

	SIZE_T takesize,disktakesize;
	OFFTYPE offset=(blocknr*MMAPBLOCKSIZE);
	if(offset>=filesize)
		return 0;
	caddr_t ptr;
	takesize=minnum(MMAPBLOCKSIZE,filesize-offset);
	disktakesize=minnum(MMAPBLOCKSIZE,diskfilesize-offset);
	 if(mmapfailed||(disktakesize>0&&((ptr=(caddr_t)MMAP(buf, disktakesize , PROT_READ|PROT_WRITE ,  MAP_PRIVATE|MAP_FIXED , file, offset))== MAP_FAILED ))) {
		mmapfailed=1;
		int len=MMAPBLOCKSIZE/ BLOCKSIZE;
		BLOCKTYPE start=blocknr*len;
		takesize=0;
		for(int iter=0;iter<len;iter++) {
			takesize+=getblock(iter+start, buf+(BLOCKSIZE*iter));
			}
		return takesize;
		}
	else {
		int len=MMAPBLOCKSIZE/ BLOCKSIZE;
		BLOCKTYPE start=blocknr*len;
		for(int iter=0;iter<len;iter++) {
			Treel *el=tree.search(iter+start);
			if(el!=tree.NIL) {
				memcpy(buf+(BLOCKSIZE*iter),el->data.buf,el->data.size);
				}
			}
		return takesize;
		}

	}
#else
SIZE_T Memory::mmapgetblock(BLOCKTYPE blocknr,char *buf) {
	SIZE_T ret;
	OFFTYPE offset=(blocknr*BLOCKSIZE);

	if(offset>=filesize)
		return 0;
	Treel *el=tree.search(blocknr);
	if(el!=tree.NIL) {
		ret=el->data.size;
		memcpy(buf,el->data.buf,ret);
		}
	else {
		caddr_t ptr;
		SIZE_T disktakesize;
		ret=minnum(BLOCKSIZE,filesize-offset);
		disktakesize=minnum(BLOCKSIZE,diskfilesize-offset);
		 if(mmapfailed||(disktakesize>0&&((ptr=(caddr_t)MMAP(buf, ret , PROT_READ|PROT_WRITE ,  MAP_PRIVATE|MAP_FIXED , file, offset))== MAP_FAILED ))) {
			mmapfailed=1;
			ret=blockreadat(buf,disktakesize,offset);
			}
		}
	return minnum(filesize-offset,ret);
	}
#endif
#else
inline SIZE_T Memory::mmapgetblock(BLOCKTYPE blocknr,char *buf) {return getblock(blocknr,buf);}
#endif
SIZE_T Memory::getblock(BLOCKTYPE blocknr,char *buf) {
	SIZE_T ret;
	OFFTYPE offset=(blocknr*BLOCKSIZE);
	if(offset>=filesize)
		return 0;
	Treel *el=tree.search(blocknr);
	if(el!=tree.NIL) {
		memmove(buf,el->data.buf,el->data.size);
		ret=el->data.size;
		}
	else {
		int len=minnum(filesize-offset,BLOCKSIZE);
		ret=blockreadat(buf,len,offset);
		}
	return minnum(filesize-offset,ret);
	}

SIZE_T Memory::putblock(BLOCKTYPE blocknr,char *buf) {
	OFFTYPE offset=(blocknr*BLOCKSIZE);
	if(offset>=filesize)
		return 0;
	SIZE_T thissize=minnum(filesize-offset,BLOCKSIZE);
	Treel *el=gettreel(blocknr);
	memmove(el->data.buf,buf,thissize);
	el->data.size=thissize;
	return thissize;
	}

void	Memory::setborder(OFFTYPE pos) {
	BLOCKTYPE under=pos/BLOCKSIZE;
	Treel *el=tree.search(under);
	if(el==tree.NIL)
		return;
	OFFTYPE offset=under*BLOCKSIZE;
	el->data.size=minnum(filesize-offset,BLOCKSIZE);
	}
void Memory::extend(OFFTYPE newsize) {
	char buf[BLOCKSIZE];
	OFFTYPE oldsize=filesize;
	BLOCKTYPE under=oldsize/BLOCKSIZE;
	Treel *el=tree.search(under);
	if(el==tree.NIL) {
		OFFTYPE begin=under*BLOCKSIZE,sizebuf=filesize-begin;
		getpart(begin,sizebuf,buf) ;
		putpart(begin,sizebuf,buf) ;
		el=tree.search(under);
		}
	filesize=newsize;
	OFFTYPE offset=under*BLOCKSIZE;
	el->data.size=minnum(filesize-offset,BLOCKSIZE);
	return;
	}
void Memory::truncatefile(OFFTYPE pos) {			/* v2 */
	Treel *el=tree.search(filesize);
	if(el!=tree.NIL) {			/**CAUTION old data is not removed. No problem: extending goes always with putpart? (extend, undo, saveall?)**/
		el->data.size=BLOCKSIZE;
		}
	filesize=pos;
	setborder(pos);
	}
SIZE_T Memory::putblockpiece(OFFTYPE  beg,SIZE_T len,char *get) {
	 BLOCKTYPE onder=beg/BLOCKSIZE;
	SIZE_T ret;
	 OFFTYPE bstart=onder*BLOCKSIZE;
	SIZE_T in=beg%BLOCKSIZE;
	Treel *el=tree.search(onder);
	SIZE_T thissize=minnum(filesize-bstart,BLOCKSIZE);
	if(el!=tree.NIL) {
		if(el->data.size<thissize) {
			fprintf(stderr,"putblockpiece %d (intree)!=%d (should)\n",el->data.size,thissize);
			char *gegs=myallocar( char,BLOCKSIZE);
			char *old; 
			ret=blockreadat(gegs,thissize,bstart);
			if(ret!=thissize) {
				fprintf(stderr,"putblockpiece %d(read)!=%d(should)\n",ret,thissize);
				}
			memmove(gegs,el->data.buf,ret);
			old=el->data.buf;
			el->data.buf=gegs;
			myfree( old);
			el->data.size=ret;
			}
		memmove(el->data.buf+in,get,len);
		}
	else {
		char *gegs=myallocar( char,BLOCKSIZE); 
		ret=blockreadat(gegs,thissize,bstart);
		/*
		if(ret!=thissize) {
			fprintf(stderr,"2:putblockpiece %d(read)!=%d(should)\n",ret,thissize);
			}*/
		memmove(gegs+in,get,len);
		tree.insert((Data){onder,gegs,thissize});
		}
	return len;
	}

OFFTYPE Memory::search(OFFTYPE beg,char *str,int len) {
#ifdef DONTINTCURSES 
DECDEST();
#endif
	OFFTYPE ret= OFFTYPEINVALID;
		switch(lastforward&0x7) {
								//forward, icase, norm
		case 3: ret= casesearch(beg,str,len);break;
		case 1: ret= icasesearch(beg,str,len);break;
		case 7:ret= regexsearch(beg,str,len);break;
		case 5: ret= icaseregexsearch(beg,str,len);break;



		case 2: ret= backsearch(beg,str,len);break;
		case 0: ret= backicasesearch(beg,str,len);break;
		case 6: ret= backregexsearch(beg,str,len);break;
		case 4: ret= backicaseregexsearch(beg,str,len);break;
		default: ret= OFFTYPEINVALID;break;
		};
#ifdef DONTINTCURSES 
INCDEST();
#endif
	return ret;
	}


OFFTYPE Memory::nextsearch(void) {
	if(!searchstr)
		return OFFTYPEINVALID;

#ifdef DONTINTCURSES 
DECDEST();
#endif
	OFFTYPE ret= OFFTYPEINVALID;
	switch(lastforward&0x7) {
		case 3: ret= nextforwardsearch();break;
		case 1: ret= nextforwardicasesearch();break;
		case 7:
		case 5: ret= nextforwardregexsearch();break;


		case 2: ret= nextbacksearch();break;
		case 0: ret= nextbackicasesearch();break;
		case 6:
		case 4: ret= nextbackregexsearch();break;
		default: ret= OFFTYPEINVALID;break;
		};
#ifdef DONTINTCURSES 
INCDEST();
#endif
	return ret;
	}

#define MYSYNTAX (RE_BK_PLUS_QM              | RE_CHAR_CLASSES                          | RE_HAT_LISTS_NOT_NEWLINE | RE_INTERVALS                             | RE_NEWLINE_ALT)

// RE_HAT_LISTS_NOT_NEWLINE

void Memory::initsearch( void) {
	if(!searchexpr){
		if(!(searchexpr=myallocp(struct re_pattern_buffer*,struct re_pattern_buffer)))
				return;
		if(!(searchregs=myallocp(struct re_registers*,struct re_registers))) {
			myfree(searchexpr);
			return;
			}
		}
	memset(searchexpr,'\0',sizeof(struct re_pattern_buffer));
	 re_set_syntax(MYSYNTAX);
	 return;
	}
OFFTYPE Memory::backicaseregexsearch(OFFTYPE beg,char *str,int len) {
	unsigned char *ta;
	int i;
	initsearch();
	searchpos=beg;
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
	memmove(searchstr,str,len);
       	searchstr[len]='\0';
	searchlen=len;
	 searchexpr->fastmap=(char *)tablebase;
	 ta=((unsigned char*)tablebase)+256;
	 for(i=0;i<0400;i++)
	 	ta[i]=i;
	 for(i='a';i<='z';i++)
	 	ta[i]=i-040;	
	 searchexpr->translate=( char*)ta;
	if((regexerrorstring=re_compile_pattern(searchstr, searchlen, searchexpr))) {
		return OFFTYPEINVALID;
	 	}
	return nextbackregexsearch(); 
	}

OFFTYPE Memory::backregexsearch(OFFTYPE beg,char *str,int len) {
	initsearch();
	searchpos=beg;
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
	memmove(searchstr,str,len);
       	searchstr[len]='\0';
	searchlen=len;
	searchexpr->translate=NULL;

	if((regexerrorstring=re_compile_pattern(searchstr, searchlen, searchexpr))) {
		return OFFTYPEINVALID;
	 	}
	 searchexpr->fastmap=(char *)tablebase;
	return nextbackregexsearch(); 
	}

//	SIZE_T Memory::getblock(BLOCKTYPE blocknr,char *buf) ;

OFFTYPE Memory::nextbackregexsearch(void) {
        char buf[3][BLOCKSIZE];
	SIZE_T count,count0;
	BLOCKTYPE bl,endblock;
	SIZE_T pos;
	SIZE_T endpos,last;
	OFFTYPE end;

	end=(searchpos+(BLOCKSIZE/2));
	endblock=end/BLOCKSIZE;
	endpos=end%BLOCKSIZE;

        bl=endblock;

        count0=getblock(bl,buf[bl&1]);
	bl--;
        if(bl>=0) {
		count=getblock(bl,buf[bl&1]);
		last=searchpos-bl*BLOCKSIZE+1;
		}
	else {
		last=searchpos+1;
		count=0;
		}

	if((pos=re_search_2(searchexpr, buf[(bl)&1], count, buf[(bl+1)&1], count0,last-1,-last+1,searchregs,count+last))!=-1) {
			if(bl<0)	
				searchpos=pos;
			else
				searchpos=pos+((bl)*BLOCKSIZE);
			return searchpos--;
			}

        for(; bl>0;) {
		bl--;
		getblock(bl,buf[bl&1]);
		if((pos=re_search_2(searchexpr, buf[(bl)&1], BLOCKSIZE, buf[(bl+1)&1], BLOCKSIZE,BLOCKSIZE-1,-BLOCKSIZE+1,searchregs,2*BLOCKSIZE))!=-1) {
			searchpos=pos+((bl)*BLOCKSIZE);
			return searchpos--;
			}
		}
	return OFFTYPEINVALID;
	}
OFFTYPE Memory::regexsearch(OFFTYPE beg,char *str,int len) {
	initsearch();
	if(!searchexpr)
		return OFFTYPEINVALID;
	searchpos=beg;
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
	memmove(searchstr,str,len);
       	searchstr[len]='\0';
	searchlen=len;
	searchexpr->translate=NULL;
	searchexpr->fastmap=(char *)tablebase;
	if((regexerrorstring=re_compile_pattern(searchstr, searchlen, searchexpr))) {
		return OFFTYPEINVALID;
	 	}
	return nextforwardregexsearch(); 
	}


OFFTYPE Memory::icaseregexsearch(OFFTYPE beg,char *str,int len) {
	unsigned char *ta;
	int i;
	initsearch();
	searchpos=beg;
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
	memmove(searchstr,str,len);
       	searchstr[len]='\0';
	searchlen=len;
	 searchexpr->fastmap=(char *)tablebase;
	 ta=((unsigned char*)tablebase)+256;
	 for(i=0;i<0400;i++)
	 	ta[i]=i;
	 for(i='a';i<='z';i++)
	 	ta[i]=i-040;	
	 searchexpr->translate=( char*)ta;

	if((regexerrorstring=re_compile_pattern(searchstr, searchlen, searchexpr))) {
		return OFFTYPEINVALID;
	 	}
	return nextforwardregexsearch(); 
	}











OFFTYPE Memory::nextforwardregexsearch(void) {
        char buf[3][BLOCKSIZE];
	SIZE_T count,count0,pos,begin;
	BLOCKTYPE bl;

	begin=searchpos%BLOCKSIZE;
        for(bl=searchpos/BLOCKSIZE,count=getblock(bl,buf[bl&1]);	count>0;) {
		bl++;
		count0=count-begin;
		count=getblock(bl,buf[bl&1]);
		if((pos=re_search_2(searchexpr, buf[(bl-1)&1]+begin, count0, buf[bl&1], count, 0, count0-1,searchregs,count0+count))!=-1) {
			searchpos=pos+((bl-1)*BLOCKSIZE)+begin;
			return searchpos++;
			}
		begin=0;
		}
	return OFFTYPEINVALID;
	}

OFFTYPE Memory::icasesearch(OFFTYPE beg,char *str,int len) {

	int i;
	memset(tablebase,0,sizeof(tablebase));
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
       	for(i=0;i<len;i++) {
       		char ch=str[i];
		table[ch]=i+1;
       		if(isup(ch)) {
       			ch=tolow(ch);
			searchstr[i]=ch;
			table[ch]=i+1;
			}
		else {
			searchstr[i]=ch;
			if(islow(ch))
				table[toup(ch)]=i+1;
			}
       		}
       	searchstr[len]='\0';
       	searchlen=len;
	searchpos=beg;
	return nextforwardicasesearch(); 
	}

OFFTYPE Memory::nextforwardicasesearch(void) {
        SIZE_T DBUFSIZE=2*BLOCKSIZE;
        char buf[3][BLOCKSIZE];
        char *start,*endstart;
	BLOCKTYPE bl;
        int i,bij=0;
	OFFTYPE endblock,ending;
	SIZE_T count;


	int endstr=searchlen-1;
        for(bl=searchpos/BLOCKSIZE,count=getblock(bl,buf[bl&1]),endblock=bl*BLOCKSIZE;	count>0;) {
                endblock+=count;
		bl++;

		count=getblock(bl,buf[bl&1]);
		endblock+=minnum(0,(count-endstr));

		ending=endblock-endstr;

                for(start=buf[0]+(searchpos%DBUFSIZE), endstart=start+(ending-searchpos) ;start<endstart;) {
                		if(table[start[endstr]]) {
                			if((bij=table[start[endstr]])==searchlen) {
						if(!strncasecmp(searchstr,start++,searchlen)) {
							searchpos=(ending-(endstart-start+1));
							return searchpos++;
							}
						}
					else
						start+=(searchlen-bij);

					}
				else
					start+=searchlen;
                                }

/*searchpos=(bl-1)*BLOCKSIZE+(start-buf[(bl-1)&1]); */
							
                for(searchpos=(ending-(endstart-start));searchpos<endblock;) {
                		if(table[buf[0][(searchpos+endstr)%(DBUFSIZE)]]) {
					if((bij=table[buf[0][(searchpos+endstr)%(DBUFSIZE)]])==searchlen) {
						for(i=0;searchstr[i]==mklow(buf[0][(searchpos+i)%(DBUFSIZE)]);i++) 
								if(i==endstr) {
									return searchpos++;
									}
						searchpos++;
						}
					else
						searchpos+=(searchlen-bij)	;
					}
				else
					searchpos+=searchlen;
				}
		}
	return OFFTYPEINVALID;
	}

OFFTYPE Memory::casesearch(OFFTYPE beg,char *str,int len) {
	int i;
	memset(tablebase,0,sizeof(tablebase));
       	for(i=0;i<len;i++) 
       		table[str[i]]=i+1;
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
       	memmove(searchstr,str,len);
       	searchstr[len]='\0';
       	searchlen=len;
	searchpos=beg;
	return nextforwardsearch(); 
	}
/*
endblock: laatste begin positie in block -1
ending: laatste begin positie van search waarvan het eind in dit bloc zit
endstart: laastste start positie waarvn het eind in dit block zit

*/
#ifndef BIGGERMMAPBLOCK
#ifndef USE_MMAP
#undef FREEMMAP
#define FREEMMAP(x,y) myfree(buf)
#undef MMAP
#define MMAP(take,len ,prot  ,flag, file, off) myallocar(char,3*BLOCKSIZE)
#define mmapgetblocker(bl) ( getblock(bl,((buf+(bl&1)*BLOCKSIZE))))
#else
#define mmapgetblocker(bl) ( mmapgetblock(bl,((buf+(bl&1)*BLOCKSIZE))))
#endif
OFFTYPE Memory::nextforwardsearch(void) {
	int nommap=1;
        SIZE_T DBUFSIZE=2*BLOCKSIZE, count;
        char *buf=(char *)MMAP(0, 3*BLOCKSIZE+EXTRAMMAP,PROT_WRITE|PROT_READ  ,MAP_PRIVATE| MAP_ANON, -1, 0);
        char *start,*endstart;
	BLOCKTYPE bl;
        int i,bij=0;
	OFFTYPE endblock,ending;
	if(buf==MAP_FAILED) {
//		puts("Mmap failed");
//		fprintf(stderr,"Mmap failed");
		mmapfailed=1;
		nommap=1;
		buf=(char *)malloc(3*BLOCKSIZE+EXTRAMMAP);
		}


	int endstr=searchlen-1;
        for(bl=searchpos/BLOCKSIZE,count=mmapgetblocker(bl),endblock=bl*BLOCKSIZE;	count>0;) {
                endblock+=count;
		bl++;

		count=mmapgetblocker(bl);
		endblock+=minnum(0,(count-endstr));

		ending=endblock-endstr;

                for(start=buf+(searchpos%DBUFSIZE),endstart=start+(ending-searchpos);start<endstart;) {
                		if(table[start[endstr]]) {
                			if((bij=table[start[endstr]])==searchlen) {
						if(!memcmp(searchstr,start++,searchlen)) {
							searchpos=(ending-(endstart-start+1));
							FREEMMAP(buf, 3*BLOCKSIZE);
							return searchpos++;
							}
						}
					else
						start+=(searchlen-bij);

					}
				else
					start+=searchlen;
                                }

							
                for(searchpos=(ending-(endstart-start));searchpos<endblock;) {
                		if(table[buf[(searchpos+endstr)%(DBUFSIZE)]]) {
					if((bij=table[buf[(searchpos+endstr)%(DBUFSIZE)]])==searchlen) {
						for(i=0;searchstr[i]==buf[(searchpos+i)%(DBUFSIZE)];i++) 
								if(i==endstr) {
									FREEMMAP(buf, 3*BLOCKSIZE);
									return searchpos++;
									}
						searchpos++;
						}
					else
						searchpos+=(searchlen-bij)	;
					}
				else
					searchpos+=searchlen;
				}
		}

	FREEMMAP(buf, 3*BLOCKSIZE);
	return OFFTYPEINVALID;
	}
#else
#ifndef USE_MMAP
#undef FREEMMAP
#define FREEMMAP(x,y) myfree(buf)
#undef MMAP
#define MMAP(take,len ,prot  ,flag, file, off) myallocar(char,3*BLOCKSIZE)
#define mmapgetblocker(bl) ( getblock(bl,((buf+(bl&1)*BLOCKSIZE))))
#else
#define mmapgetblocker(bl) ( mmapgetblock(bl,((buf+(bl&1)*MMAPBLOCKSIZE))))
#endif
#define  TAKEBLOCKS 2
OFFTYPE Memory::nextforwardsearch(void) {
	int nommap=0;
        SIZE_T DBUFSIZE=2*MMAPBLOCKSIZE, count;
        char *start,*endstart;
	BLOCKTYPE bl;
        int i,bij=0;
	OFFTYPE endblock,ending;
        char *buf;
	if(mmapfailed||(buf=(char *)MMAP(0, TAKEBLOCKS*MMAPBLOCKSIZE+EXTRAMMAP,PROT_WRITE|PROT_READ  ,MAP_PRIVATE| MAP_ANON, -1, 0))==MAP_FAILED) {
	//	fprintf(stderr,"\7nextforwaredsearch MMAP failed!!!! Not searched\7");
		mmapfailed=1;
		nommap=1;
		buf=(char *)malloc(TAKEBLOCKS*MMAPBLOCKSIZE+EXTRAMMAP);
		}


	int endstr=searchlen-1;
        for(bl=searchpos/MMAPBLOCKSIZE,count=mmapgetblocker(bl),endblock=bl*MMAPBLOCKSIZE;	count>0;) {
                endblock+=count;
		bl++;

		count=mmapgetblocker(bl);
		endblock+=minnum(0,(count-endstr));

		ending=endblock-endstr;

                for(start=buf+(searchpos%DBUFSIZE),endstart=start+(ending-searchpos);start<endstart;) {
                		if(table[start[endstr]]) {
                			if((bij=table[start[endstr]])==searchlen) {
						if(!memcmp(searchstr,start++,searchlen)) {
							searchpos=(ending-(endstart-start+1));
							FREEMMAP(buf, TAKEBLOCKS*MMAPBLOCKSIZE);
							return searchpos++;
							}
						}
					else
						start+=(searchlen-bij);

					}
				else
					start+=searchlen;
                                }

/*searchpos=(bl-1)*BLOCKSIZE+(start-buf[(bl-1)&1]); */
							
                for(searchpos=(ending-(endstart-start));searchpos<endblock;) {
                		if(table[buf[(searchpos+endstr)%(DBUFSIZE)]]) {
					if((bij=table[buf[(searchpos+endstr)%(DBUFSIZE)]])==searchlen) {
						for(i=0;searchstr[i]==buf[(searchpos+i)%(DBUFSIZE)];i++) 
								if(i==endstr) {
									FREEMMAP(buf, TAKEBLOCKS*MMAPBLOCKSIZE);
									return searchpos++;
									}
						searchpos++;
						}
					else
						searchpos+=(searchlen-bij)	;
					}
				else
					searchpos+=searchlen;
				}
		}

	FREEMMAP(buf, TAKEBLOCKS*MMAPBLOCKSIZE);
	return OFFTYPEINVALID;
	}
#endif
OFFTYPE Memory::backsearch(OFFTYPE beg,char *str,int len) {
	int i;
	for(i=SCHAR_MIN;i<=SCHAR_MAX;i++)
		table[i]=-1;
       	for(i=len-1;i>=0;i--) 
       		table[str[i]]=i;
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
       	memmove(searchstr,str,len);
       	searchstr[len]='\0';
       	searchlen=len;
	searchpos=beg;
	return nextbacksearch(); 
	}

OFFTYPE Memory::nextbacksearch(void) {
        char buf[3][BLOCKSIZE];
        char *start,*vorig,*huidig;
	BLOCKTYPE bl;
        int bij;
	SIZE_T count,hierin;
/**	int endstr=searchlen-1; **/

	bl=((searchpos+searchlen)/BLOCKSIZE);
	hierin=((searchpos+searchlen)%BLOCKSIZE);

	vorig=buf[bl&1];
	if(((count=getblock(bl,vorig))>0)&&(hierin>=searchlen)) {
			for(start=vorig+hierin-searchlen;start>=vorig;) {
					if(table[*start]<0)
						start-=searchlen;
					else  {
						if((bij=table[*start])) 
							start-=bij;
						else {
							if(!memcmp(searchstr,start--,searchlen)) {
								searchpos=bl*BLOCKSIZE+(start-vorig+1);
								return searchpos--;
								}
							}

						}
					}
		}
	hierin=maxnum(1,searchlen-hierin);

        for(bl-- ;(bl>=0&&(huidig=buf[bl&1],((count=getblock(bl,huidig))>0)));bl--,vorig=huidig) {
		for(start=huidig+BLOCKSIZE;hierin<searchlen;) {
			if(table[*(start-hierin)]<0)
				hierin+=searchlen;
			else  {
				if((bij=table[*(start-hierin)])) 
					hierin+=bij;
				else {
					if(!(memcmp(searchstr+hierin,vorig,(searchlen-hierin))||memcmp(searchstr,start-hierin,hierin))) {
									searchpos=bl*BLOCKSIZE+BLOCKSIZE-hierin;
									return searchpos--;
									}
					hierin++;
					}
				}
			}
		start-=hierin;
		hierin=1;

                for(;start>=huidig;) {
					if(table[*start]<0)
						start-=searchlen;
					else  {
						if((bij=table[*start])) 
							start-=bij;
						else {
							if(!memcmp(searchstr,start--,searchlen)) {
								searchpos=bl*BLOCKSIZE+(start-huidig+1);
								return searchpos--;
								}
							}

						}

                                }

		}
	return OFFTYPEINVALID;
	}


OFFTYPE Memory::backicasesearch(OFFTYPE beg,char *str,int len) {
	int i;
	for(i=SCHAR_MIN;i<=SCHAR_MAX;i++)
		table[i]=-1;
       	for(i=len-1;i>=0;i--)  {
       		table[mklow(str[i])]=i;
       		table[mkup(str[i])]=i;
       		}
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
       	for(i=0;i<len;i++)
       		searchstr[i]=mklow(str[i]);
       	searchstr[len]='\0';
       	searchlen=len;
	searchpos=beg;
	return nextbackicasesearch(); 
	}

OFFTYPE Memory::nextbackicasesearch(void) {
        char buf[3][BLOCKSIZE];
        char *start,*vorig,*huidig;
	BLOCKTYPE bl;
        int bij,hierin;
	SIZE_T count=searchlen;
//	int endstr=searchlen-1;

	bl=((searchpos+searchlen)/BLOCKSIZE);
	hierin=((searchpos+searchlen)%BLOCKSIZE);

	vorig=buf[bl&1];
	if(((count=getblock(bl,vorig))>0)&&(hierin>=searchlen)) {
			for(start=vorig+hierin-searchlen;start>=vorig;) {
					if(table[*start]<0)
						start-=searchlen;
					else  {
						if((bij=table[*start])) 
							start-=bij;
						else {
							if(!strncasecmp(searchstr,start--,searchlen)) {
								searchpos=bl*BLOCKSIZE+(start-vorig+1);
								return searchpos--;
								}
							}

						}
					}
		}
	hierin=maxnum(1,searchlen-hierin);

        for(bl-- ;(bl>=0&&(huidig=buf[bl&1],((count=getblock(bl,huidig))>0)));bl--,vorig=huidig) {
		for(start=huidig+BLOCKSIZE;hierin<searchlen;) {
			if(table[*(start-hierin)]<0)
				hierin+=searchlen;
			else  {
				if((bij=table[*(start-hierin)])) 
					hierin+=bij;
				else {
					if(!(strncasecmp(searchstr+hierin,vorig,(searchlen-hierin))||strncasecmp(searchstr,start-hierin,hierin))) {
									searchpos=bl*BLOCKSIZE+BLOCKSIZE-hierin;
									return searchpos--;
									}
					hierin++;
					}
				}
			}
		start-=hierin;
		hierin=1;

                for(;start>=huidig;) {
					if(table[*start]<0)
						start-=searchlen;
					else  {
						if((bij=table[*start])) 
							start-=bij;
						else {
							if(!strncasecmp(searchstr,start--,searchlen)) {
								searchpos=bl*BLOCKSIZE+(start-huidig+1);
								return searchpos--;
								}
							}

						}

                                }

		}
	return OFFTYPEINVALID;

	}

int Memory::setsearchgegs(OFFTYPE beg,char *str,int len) {
	initsearch();
	if(!searchexpr)
			return -1;
	searchpos=beg;
       	if(searchstr)
       		myfree( searchstr);
       	searchstr =myallocarp(char *,char,len+1);
	memmove(searchstr,str,len);
       	searchstr[len]='\0';
	searchlen=len;
	searchexpr->fastmap=(char *)tablebase;
	if(casesearching(this)) 
		searchexpr->translate=NULL;
	else {
		int i;
		unsigned char *ta;
		 ta=((unsigned char*)tablebase)+256;
		 for(i=0;i<0400;i++)
			ta[i]=i;
		 for(i='a';i<='z';i++)
			ta[i]=i-040;	
		 searchexpr->translate=( char*)ta;
		}

	if((regexerrorstring=re_compile_pattern(searchstr, searchlen, searchexpr))) {
		return -1;
	 	}

	return 0;
	}

#ifdef TEST
#include "basic.h"
int main(int argc, char **argv) {
#define MAXBUF 0xffff
	int pos,len;
	char buf[MAXBUF];
	char command[256]="cat   /tmp/memoryXXXXXX",*hierfile=command+6;
	if(argc!=2) {
		fprintf(stderr,"Gebruik: %s filename\n",argv[0]);
		exit(1);
		}
	Memory mem(argv[1]);

	if(mem.error())	{
		fprintf(stderr,"%s: error \n",argv[0]);
		exit(2);
		}
	printf("size=%d\n",mem.size());
	puts("Give filepostition and lenght (pos len)");
	while(gets(buf)) {
		if(buf[0]=='q')
			break;
		if((sscanf(buf,"%d %d",&pos,&len)<2)||len>MAXBUF)
			continue;
		int handle,newlen;
		newlen=mem.getpart(pos,len,buf);
		strcpyn(hierfile+11,"XXXXXX",239);
		if(!(mktemp(hierfile)))
			fatal("tmpnam(/tmp/memory) fails\n");
		puts(hierfile);
		if((handle=creat(hierfile,0600))<0)
			fatal("creat(%s)\n",hierfile);
		write(handle,buf,newlen);
		LCLOSE(handle);
		system(command);
		if((handle=LOPEN(hierfile,O_RDONLY BINARY_FLAG))<0)
			fatal("Can't open %s for readonly\n",hierfile);
		seekread(handle,0L,SEEK_SET,buf,newlen);
		LCLOSE(handle);
		len=mem.putpart(pos,len,buf);
		puts("Give filepostition and lenght (pos len)");
		}
	mem.tree.showtree();
	puts("Save file (j/n)");
	gets(buf);
	if(buf[0]=='j') {
		mem.saveall();
		puts("Saved");
		}
	mem.tree.showtree();
	return 0;
	}
myread(
#endif
